



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>关于iOS中的文本操作-管理text fields 和 text views</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">关于iOS中的文本操作-管理text fields 和 text views</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 01:55:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Managing Text Fields and Text Views</p>
<p>管理UITextField和UITextView实例</p>
<p>UITextField和UITextView的实例拥有两个最主要的功能：展示文本和输入、编辑文本。许多程序的任务都和这些简单的目的有关，包括配置文本属性，访问文本内容，确认用户输入以及展示一些其它的视图（例如在uitextfield中添加标签按钮）。</p>
<p>UITextField和UITextView的代理负责以上所说的大部分任务，代理必须遵守UITextFieldDelegate和UITextViewDelegate协议，并且实现其中的一个或多个方法。协议中所有的方法都是可选的。为了能让程序调用这些代理方法，你必须用代码或者interface builder中设置代理。</p>
<p>向代理发送消息的顺序</p>
<p>在大多数情况下，当处于第一响应者状态的UITextField或者UITextView类的实例发生变化（或者即将发生变化）时，会发送一系列名字相似的消息他们的代理。当用户点击一个文本对象时，它会自动成为第一响应者，然后系统会弹出键盘，开始编辑那个文本对象。当用户点击了另外一个文本对象或者点击了结束编辑的按钮，当前的文本对象失去第一响应者状态。如果没有选中其它文本对象，系统会隐藏键盘，如果选中了其它的文本对象，它会成为第一响应者，并且系统会为它弹出键盘。</p>
<p>对于键盘退出的行为有两种行为：其一、在iPad上，当一个视图控制器通过&ldquo;form sheet&rdquo;的样式模态显示了它的视图，键盘一旦弹出便不会隐藏，除非用户点击隐藏按钮或者模态视图消息。这种做法的目的是位了避免用户在非常大的视图上移动时造成过度动画。另外一个情况是调用自定义的键盘，自定义键盘是通过自定义一个视图，并赋值给text view的inputView属性，用来替代系统键盘的。当存在自定义键盘时，即便当前文本对象是第一响应者，UIKit也回退出系统键盘，并根据开发者关于设置弹出类似键盘的键盘。</p>
<p>UITextField和UITextView实例向它们的代理发送消息的顺序如下：</p>
<p>1.当一个文本对象成为第一响应者之前- textFieldShouldBeginEdinting:(text field) 和 textViewShouldBeginEditing:(text view)</p>
<p>代理会确定是否当前文本对象应该成为第一响应者，默认返回值YES 允许成为第一响应者</p>
<p>2.在一个文本对象成为第一响应者之后- textFieldDidBeginEditing:(text field) 和 textViewDidBeginEditing:(text view).</p>
<p>代理会通过更新状态信息（例如，编辑的过程中在text view里显示一个视图）来响应这条消息</p>
<p>3.在编辑的过程中-各方面的</p>
<p>当用户输入和编辑文本的时候，文本对象会调用某些已经实现的代理方法，例如，当文本变化时，代理会收到一条 textViewDidChange:消息；当用户点击清除按钮时，代理会收到textFieldShouldClear:消息，并返回一个布尔类型的值用来决定是否文本应该被清除。</p>
<p>4.在一个文本对象即将失去第一响应者之前-textFieldShouldEndEditing:(text field) 和 textViewShouldEndEdinting:(text view)</p>
<p>代理实现这些方法最主要的原因是确认文本输入。比如当文本需要遵守一个固定格式时，代理可以确认输入的文本是否符合要求并返回对应的布尔值。</p>
<p>对于UITextField的实例，有一个相关的方法textFieldShouldReturn： 当用户点击了&ldquo;return&rdquo;键时，文本框会向代理发送这个消息询问是否应该放弃第一响应者</p>
<p>5.当文本框失去第一响应者之后-textFieldDidEndEditing:(text field) 和 textViewDidEditing:(text view).</p>
<p>代理可以通过实现这些方法来获得用户刚刚输入或编辑的文本内容。</p>
<p>其它非代理对象可以通过观察成为第一响应者的状态变化通知来获取文本的变化（但是，这些对象不能决定文本的状态）通知主要包括：UITextFieldTextDidBeginEditingNotification, UITextViewDidEndEditingNotification,UITextFieldTextDidChangeNotification.</p>
<p>无论代理还是监听通知，最主要的目的都是为了访问与文本框有关的文本内容。</p>
<p>See UITextField Class Reference and UITextView Class Reference to learn more about the notifications posts by these classes.</p>
<p>配置文本框和文本视图</p>
<p>。。。。待续</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxoy2jq.html">python引用py文件中文报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zepwd8.html">struts 用拦截器进行用户权限隔离，未登录用户跳到登录界面  &ast;&ast;&ast; 最爱那水货</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mv75p8.html">NGUI 滑动页&lpar;UIToggle和UIToggledObjects&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96np7yq.html">建立和断开与MySQL服务器的连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvw6lo9.html">ArcGIS Javascript查询数据库并添加到地图上</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2zxr3q.html">pgadmin中的备份功能消失的原因和找回方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0v3vq.html">在一个XAML中点击按钮，界面跳转到另一个XAML界面方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2p2zx8.html">API的非向后兼容性无论如何通常代表着一种比较差的设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv0kojq.html">给VPS装桌面</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj36249.html">2014--9&equals;17 软工二班 MyEclipse blue&equals;&equals;5</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnkj56q.html">2、列表item&lowbar;圆头像&lowbar;信息提示</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0x00eq.html">BZOJ &lbrack;ZJOI2008&rsqb;泡泡堂BNB 贪心</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05n50q.html">Android与JS混编（js调用java）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m6vvxq.html">Opencv--HoughCircles源码剖析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd744k8.html">从头编译ARM交叉编译环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/9500r6z8.html">Android中目的地Intent的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j5zkv8.html">URL 调度器&lpar;URL dispatcher&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojo53xq.html">通过Git Gui Here上传本地项目到GitHub上</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jl61l8.html">Activiti初学问题，求解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdryly9.html">树莓派3B&plus;&lpar;一&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwd0pwl8.html">Java根据一个网址链接获取源代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn156w38.html">&lbrack;老老实实学WCF&rsqb; 第三篇 在IIS中寄存服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd0pmz8.html">HTML&plus;CSS学习笔记 &lpar;13&rpar; - CSS代码缩写，占用更少的带宽</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zjxl29.html">RSA 加解密</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vexz38.html">mybatis 聚合查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxne3yz8.html">Codevs 2898 卢斯的进位制</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xnzkn9.html">cookie&plus;session&comma;会话时间设定</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w0473q.html">Qt for Android 程序禁止屏幕旋转</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv042oq.html">&OpenCurlyDoubleQuote;&equals;&equals;&rdquo;，比较的是引用    &OpenCurlyDoubleQuote;equals方法&rdquo;比较的是具体内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0pwvgq.html">简单的jQuery获取URL的？后带的参数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
